## ntpsec 1.2.3%2Bdfsg1

=== debian/control ===
Source: ntpsec
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Richard Laager <rlaager@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-apache2,
               dh-apparmor,
               dh-python,
               asciidoctor,
               bison,
               docbook-xsl,
               libbsd-dev,
               libcap2-dev [linux-any],
               libssl-dev,
               netbase,
               pkgconf,
               pps-tools [linux-any],
               python3,
               python3-dev,
               python3-gps,
               python3-setuptools,
               systemd-dev,
               xsltproc,
               xz-utils,
Build-Conflicts: libavahi-compat-libdnssd-dev,
                 libwww-dev,
                 libwww-ssl-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian/ntpsec
Vcs-Git: https://salsa.debian.org/debian/ntpsec.git
Homepage: https://www.ntpsec.org

Package: ntpsec
Architecture: any
Pre-Depends: ${misc:Pre-Depends},
Depends: adduser,
         netbase,
         python3,
         python3-ntp (= ${binary:Version}),
         tzdata,
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: systemd | cron | cron-daemon,
Suggests: apparmor,
          certbot,
          ntpsec-doc,
          ntpsec-ntpviz,
Breaks: ntp (<< 1:4.2.8p15+dfsg-2~),
Conflicts: time-daemon,
Provides: time-daemon,
Replaces: ntp (<< 1:4.2.8p15+dfsg-2~),
          time-daemon,
Description: Network Time Protocol daemon and utility programs
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains the NTP daemon and utility programs.  An NTP
 daemon needs to be running on each host that is to have its clock
 accuracy controlled by NTP.  The same NTP daemon is also used to
 provide NTP service to other hosts.
 .
 This is the NTPsec version of NTP.  NTPsec is a secure, hardened,
 and improved implementation derived from the original NTP project.
 NTPsec supports Network Time Security (NTS) which provides
 cryptographically authenticated time.
 .
 For more information about the NTP protocol and NTP server
 configuration and operation, install the package "ntpsec-doc".

Package: ntpsec-ntpdate
Architecture: any
Depends: netbase,
         ntpsec-ntpdig (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: ntpdate (<< 1:4.2.8p15+dfsg-2~),
Replaces: ntpdate (<< 1:4.2.8p15+dfsg-2~),
Description: client for setting system time from NTP servers
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpdate is a simple NTP client that sets a system's clock to match
 the time obtained by communicating with one or more NTP servers.  It
 is not sufficient, however, for maintaining an accurate clock in the
 long run.  ntpdate by itself is useful for occasionally setting the
 time on machines that do not have full-time network access, such as
 laptops.
 .
 This is the NTPsec version of ntpdate.  NTPsec is a secure, hardened,
 and improved implementation derived from the original NTP project.
 .
 If the full NTP daemon from the package "ntpsec" is installed, then
 ntpsec-ntpdate is not necessary.

Package: ntpsec-ntpdig
Architecture: any
Depends: python3 (>= 3.3),
         python3-ntp (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Breaks: ntpsec-ntpdate (<< 1.2.1+dfsg1-5~),
        sntp (<< 1:4.2.8p15+dfsg-2~),
Replaces: ntpsec-ntpdate (<< 1.2.1+dfsg1-5~),
          sntp (<< 1:4.2.8p15+dfsg-2~),
Description: ntpdig SNTP client
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpdig can be used as an SNTP client to query a NTP or SNTP server
 and either display the time or set the local system's time.  It is not
 sufficient, however, for maintaining an accurate clock in the long run.
 .
 This is the NTPsec version of ntpdig, which is equivalent to the sntp
 utility.  NTPsec is a secure, hardened, and improved implementation
 derived from the original NTP project.

Package: ntpsec-ntpviz
Architecture: any
Depends: adduser,
         fonts-liberation,
         gnuplot-nox | gnuplot,
         python3,
         python3-ntp (= ${binary:Version}),
         systemd | cron | cron-daemon,
         ${misc:Depends},
Recommends: ntpsec,
            systemd | python3-psutil,
            ${misc:Recommends},
Suggests: python3-gps,
Description: NTP statistics graphing utility
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 ntpviz analyzes NTP log files and generates statistical plots from
 them.  The output is in the form of HTML with images.  If Apache is
 installed, it will be served at: /ntpviz
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

Package: ntpsec-doc
Architecture: all
Depends: ${misc:Depends},
Breaks: ntp-doc (<< 1:4.2.8p15+dfsg-2~),
Replaces: ntp-doc (<< 1:4.2.8p15+dfsg-2~),
Section: doc
Multi-Arch: foreign
Description: Network Time Protocol documentation
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains HTML documentation for the ntpsec packages (ntpsec,
 ntpsec-ntpdate).
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

Package: python3-ntp
Architecture: any
Depends: python3,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends},
Provides: ${python3:Provides},
Section: python
Description: Python 3 NTP Helper Classes
 NTP, the Network Time Protocol, is used to keep computer clocks
 accurate by synchronizing them over the Internet or a local network,
 or by following an accurate hardware receiver that interprets GPS,
 DCF-77, or similar time signals.
 .
 This package contains the Python "ntp" module, which contains helper
 classes for NTP utilities written in Python.
 .
 This is part of NTPsec.  NTPsec is a secure, hardened, and improved
 implementation derived from the original NTP project.

## ntpsec 1.2.3+dfsg1

=== wscript ===
from __future__ import print_function

from datetime import datetime
import itertools
import os
import shlex
import sys
import time

from waflib import Build
from waflib import Context
from waflib import Scripting
from waflib import Utils
from waflib.Build import (BuildContext, CleanContext, InstallContext,
                          StepContext, ListContext)
from waflib.Context import BOTH
from waflib.Errors import WafError
from waflib.Logs import pprint
from waflib.Tools import waf_unit_test

# Avoid writing .pyc files in wafhelpers/
sys.dont_write_bytecode = True

from wafhelpers.options import options_cmd
from wafhelpers.probes import probe_header, probe_function
from wafhelpers.test import test_write_log, test_print_log


pprint.__doc__ = None

APPNAME = 'ntpsec'

out = "build"

config = {
    "out": out,
    "OPT_STORE": {}
}


def help(ctx):
    "Be helpful, give a usage"
    print('''
Usage: waf <command>
    build       Build the project
    check       Run tests
    configure   Configure the project
    dist        Create a release
    install     Install the project
    loccount    Show SLOC count of the source tree
    uninstall   Uninstall the project

''')


def options(ctx):
    options_cmd(ctx, config)
    ctx.load('asciidoc', tooldir='wafhelpers/')
    ctx.recurse("pylib")


def configure(ctx):
    ctx.load('asciidoc', tooldir='wafhelpers/')

    class oc(Build.BuildContext):
        cmd = 'oc'

        def exec_command(self, cmd, **kw):
            kw['output'] = BOTH
            try:
                err, out = self.cmd_and_log(cmd, **kw)
            except WafError as e:
                self.logger.debug('WafError')
                return e.returncode
            if (len(out) and any(word in out for word
                                 in ['err', 'err:', 'error', 'error:',
                                     'ignored', 'illegal', 'unknown',
                                     'unrecognized', 'warning'])):
                self.logger.debug('noooo %r' % out)
                return 1
            if err:
                self.logger.debug('noooo %r' % err)
                return 1
            return 0

    def msg(str):
        pprint("YELLOW", str)

    def msg_setting(name, val):
        pprint("NORMAL", "  %-30s: " % name, sep="")
        pprint("YELLOW", val)

    srcnode = ctx.srcnode.abspath()
    bldnode = ctx.bldnode.abspath()

    ctx.run_build_cls = 'check'
    ctx.load('waf', tooldir='wafhelpers/')
    ctx.load('waf_unit_test')
    ctx.load('gnu_dirs')

    with open("VERSION", "r") as f:
        ntpsec_release = f.read().split(" ")[0].strip()

    ctx.env.OPT_STORE = config["OPT_STORE"]

    opt_map = {}
    # Wipe out and override flags with those from the commandline
    for flag in ctx.env.OPT_STORE:
        if flag == "--undefine":
            for sym in ctx.env.OPT_STORE[flag]:
                ctx.undefine(sym)
        elif flag == "--define":
            for symval in ctx.env.OPT_STORE[flag]:
                (sym, val) = symval.split("=")
                try:
                    ctx.define(sym, int(val))
                except ValueError:
                    ctx.define(sym, val)
        else:
            opt = flag.replace("--", "").upper()
            opt_map[opt] = ctx.env.OPT_STORE[flag]

    ctx.env['ntpc'] = ctx.options.enable_pylib
    ctx.env['ntpcver'] = '1.1.0'

    msg("--- Configuring host ---")
    ctx.setenv('host', ctx.env.derive())

    ctx.load('compiler_c')
    ctx.start_msg('Checking compiler version')
    ctx.end_msg("%s" % ".".join(ctx.env.CC_VERSION))

    # Some distros do not have /sbin in the PATH for non-root users.  We honor
    # the real PATH first, but append the sbin directories.
    ctx.find_program(
        "ldconfig", var="BIN_LDCONFIG", mandatory=False,
        path_list=(os.environ.get('PATH','').split(os.pathsep) +
            ["/sbin", "/usr/sbin", "/usr/local/sbin"]))

    # Ensure m4 is present, or bison will fail with SIGPIPE
    ctx.find_program('m4')
    ctx.load('bison')

    for opt in opt_map:
        ctx.env[opt] = opt_map[opt]

    if ctx.options.enable_rtems_trace:
        ctx.find_program("rtems-tld", var="BIN_RTEMS_TLD",
                         path_list=[ctx.options.rtems_trace_path,
                                    '${BINDIR}'])
        ctx.env.RTEMS_TEST_ENABLE = True
        ctx.env.RTEMS_TEST_FLAGS = [
            "-C", "%s/devel/trace/ntpsec-trace.ini" % srcnode,
            "-W", "%s/ntpsec-wrapper" % bldnode,
            "-P", "%s/devel/trace/" % srcnode,
            "-f", "-I%s" % bldnode,
            "-f", "-I%s/include/" % srcnode,
        ]

    # Not needed to build.  Used by utility scripts.
    ctx.find_program("awk", var="BIN_AWK", mandatory=False)
    ctx.find_program("sh", var="BIN_SH", mandatory=False)

    ctx.check_cfg(
        package='systemd', variables=['systemdsystemunitdir'],
        uselib_store='SYSTEMD', mandatory=False,
        msg="Checking for systemd")
    if ctx.env.SYSTEMD_systemdsystemunitdir:
        ctx.start_msg("systemd unit directory:")
        ctx.end_msg(ctx.env.SYSTEMD_systemdsystemunitdir)

    ctx.env.BIN_GIT = False
    if os.path.exists(".git"):
        ctx.find_program("git", var="BIN_GIT", mandatory=False)

    build_desc = ctx.options.build_desc.strip()
    if build_desc:
        build_desc = ' ' + build_desc
    if ctx.env.BIN_GIT:
        # 'tag', '7', and 'deadbeef' are fill ins for
        # a previous tag (always dropped), commits since that tag,
        # the short commit hash. I can see 5 'git describe' outputs
        # buildbots and prepush should get: tag-7-gdeadbeef
        # working developers should get: tag-7-gdeadbeef-dirty
        # patched shallow builders should get: gdeadbeef-dirty
        # other shallow builder should get: gdeadbeef
        # the thorium poisoned get errors and burst into flame
        # 1-2 tokens gets appended verbatim
        # 3-4 gets the first token dropped and the rest added
        # I have never seen 5+ tokens, we should be safe
        cmd = ctx.env.BIN_GIT + shlex.split("describe --tags --dirty --always")
        git_short_hash = ctx.cmd_and_log(cmd).strip().split('-')
        clip = 1 if len(git_short_hash) > 2 else 0
        git_short_hash = '-'.join(git_short_hash[clip:])

        ctx.env.NTPSEC_VERSION = "%s+" % ntpsec_release
        ctx.env.NTPSEC_VERSION_EXTENDED = ("%s+%s%s" %
                                           (ntpsec_release,
                                            git_short_hash,
                                            build_desc))
    else:
        ctx.env.NTPSEC_VERSION = "%s" % ntpsec_release
        ctx.env.NTPSEC_VERSION_EXTENDED = ("%s%s" % (ntpsec_release,
                                                      build_desc))
    ctx.define("NTPSEC_VERSION", ctx.env.NTPSEC_VERSION)
    ctx.define("NTPSEC_VERSION_EXTENDED", ctx.env.NTPSEC_VERSION_EXTENDED)

    # We require some things that C99 doesn't enable, like pthreads.
    # These flags get propagated to both the host and main parts of the build.
    #
    # _POSIX_C_SOURCE
    #      If ==1, like _POSIX_SOURCE;
    #      if >=2 add IEEE Std 1003.2;
    #      if >=199309L, add IEEE Std 1003.1b-1993;
    #      if >=199506L, add IEEE Std 1003.1c-1995;
    #      if >=200112L, all of IEEE 1003.1-2004
    #      if >=200809L, all of IEEE 1003.1-2008
    #
    # FIXME: We'd like this to be -D_POSIX_C_SOURCE=200809L -D_XOPEN_SOURCE=700
    # rather than -D_GNU_SOURCE, but that runs into problems in two places:
    # (1) The ISC net handling stuff, where struct in6_addr’ loses a member
    # named s6_addr32 that the macros need, and (2) three BSD functions
    # related to chroot jailing in the sandbox code.
    #
    # Note that _POSIX_C_SOURCE >= 199506L and _GNU_SOURCE both turn on
    # _POSIX_PTHREAD_SEMANTICS and _REENTRANT
    #
    ctx.env.CFLAGS = ["-std=c99", "-D_GNU_SOURCE"] + ctx.env.CFLAGS

    msg("--- Configuring main ---")
    ctx.setenv("main", ctx.env.derive())

    from wafhelpers.check_sizeof import check_sizeof

    for opt in opt_map:
        ctx.env[opt] = opt_map[opt]

    if ctx.options.cross_compiler:
        ctx.env.ENABLE_CROSS = True

        ctx.start_msg("Using Cross compiler CC:")
#           ctx.get_cc_version(ctx.env.CC, gcc=True)
        ctx.end_msg(ctx.options.cross_compiler)

        ctx.env.CC = shlex.split(ctx.options.cross_compiler)
        ctx.env.LINK_CC = shlex.split(ctx.options.cross_compiler)

        if ctx.env["CROSS-CFLAGS"]:
            # Lexically split each part of the CFLAGS, then chain the lists
            iter = [shlex.split(x) for x in opt_map["CROSS-CFLAGS"]]
            ctx.env.CFLAGS = list(itertools.chain.from_iterable(iter))

        if ctx.env["CROSS-LDFLAGS"]:
            # Lexically split each part of the LDFLAGS, then chain the lists
            iter = [shlex.split(x) for x in opt_map["CROSS-LDFLAGS"]]
            ctx.env.LDFLAGS = list(itertools.chain.from_iterable(iter))

    if ctx.options.list:
        from wafhelpers.refclock import refclock_map
        print("ID    Description")
        print("~~    ~~~~~~~~~~~")
        for id in refclock_map:
            print("%-5s %s" % (id, refclock_map[id]["descr"]))

        return

    # These are required by various refclocks
    # needs to be tested before CFLAGS are set
    if ctx.check_endianness() == "big":
        ctx.define("WORDS_BIGENDIAN", 1)

    if ctx.options.enable_leap_testing:
        ctx.define("ENABLE_LEAP_TESTING", 1,
                   comment="Enable leap seconds on other than 1st of month.")

    # check for some libs first.  some options, like stack protector,
    # may depend on some libs, like -lssp
    ctx.check_cc(lib="m", comment="Math library")
    ctx.check_cc(lib="rt", mandatory=False, comment="realtime library")
    ctx.check_cc(lib="pthread", mandatory=False, comment="threads library")
    ctx.check_cc(lib="execinfo", mandatory=False,
                 comment="BSD backtrace library")
    ret = ctx.check_cc(lib="bsd", mandatory=False,
                       comment="BSD compatibility library")
    if ret:
        ctx.env.LDFLAGS += ["-lbsd"]

    # -lssp and -lssp_nonshared may be needed by older gcc to
    # support "-fstack-protector-all"
    ret = ctx.check_cc(lib="ssp", mandatory=False,
                       comment="libssp")
    if ret:
        ctx.env.LDFLAGS += ["-lssp"]

    ret = ctx.check_cc(lib="ssp_nonshared", mandatory=False,
                       comment="libssp_nonshared")
    if ret:
        ctx.env.LDFLAGS += ["-lssp_nonshared"]

    cc_test_flags = [
        ('PIC', '-fPIC'),
        ('PIE', '-pie -fPIE'),
        # this quiets most of macOS warnings on -fpie
        ('unused', '-Qunused-arguments'),
        # This is a useless warning on any architecture with a barrel
        # shifter, which includes Intel and ARM and basically
        # everything nowadays. Even so, we'd enable it out of
        # perfectionism, but the GCC directives that ought to be
        # useful for forcing structure alignment in order to suppress
        # it locally don't seem to be working quite right.
        # ('w_cast_align', "-Wcast-align"),
        ('w_cast_qual', "-Wcast-qual"),
        ('w_disabled_optimization', "-Wdisabled-optimization"),
        ('w_float_equal', "-Wfloat-equal"),
        ('w_format', '-Wformat'),
        ('w_format_security', '-Wformat-security'),
        # fails on OpenBSD 6
        ('w_format_signedness', '-Wformat-signedness'),
        ('w_implicit_function_declaration', "-Wimplicit-function-declaration"),
        ('w_init_self', '-Winit-self'),
        ('w_invalid_pch', '-Winvalid-pch'),
        ('w_missing_declarations', '-Wmissing-declarations'),
        ('w_multichar', '-Wmultichar'),
        ('w_packed', '-Wpacked'),
        ('w_pointer_arith', '-Wpointer-arith'),
        ('w_shadow', '-Wshadow'),
        # fails on clang
        ('w_suggest_attribute_noreturn', "-Wsuggest-attribute=noreturn"),

=== attic/wscript ===
def build(ctx):
    util = [    'sht',
                'digest-find', 'cipher-find',
		'clocks', "random",
                'digest-timing', 'cmac-timing',
                'backwards']

    if not ctx.env.DISABLE_NTS:
        util.append('aes-siv-timing')

    for name in util:
        ctx(
            target=name,
            features="c cprogram",
            includes=[ctx.bldnode.parent.abspath(), "../include", "../libaes_siv"],
            source=[name + ".c"],
            use="ntp M CRYPTO RT PTHREAD aes_siv",
            install_path=None,
        )

=== libaes_siv/wscript ===
def build(ctx):
    aes_cflags=['-Wno-shadow',
            # '-Wall', '-Wextra', '-Wstrict-prototypes',  # default
            # '-Wconversion',  # Overzealous in GCC 4.2
            '-O3',
            '-fomit-frame-pointer',
            '-funroll-loops',
            '-ftree-vectorize',
            '-Wno-inline',  # gcc 10 gives inline warnings?
            ]


    ctx(
        target='aes_siv',
        features='c cstlib',
        includes=[ctx.bldnode.parent.abspath()],
        source='aes_siv.c',
        use='CRYPTO',
        cflags=aes_cflags,
    )

    ctx(
        target="runtests",
        features="c cprogram test",
        includes=[ctx.bldnode.parent.abspath()],
        source=[
            "aes_siv_test.c",
            "tests.c",
        ],
        install_path=None,
        use="aes_siv",
        cflags=aes_cflags,
    )

=== tests/wscript ===
import os
from waflib import Utils  # pylint: disable=import-error


def build(ctx):
    testsrc = ctx.srcnode.make_node('tests')
    pylib = ctx.srcnode.make_node('pylib')
    testpylib = testsrc.make_node('pylib')
    testpysrc = testpylib.ant_glob('*.py')

    # Unity source
    unity_source = [
        "unity/unity.c",
        "unity/unity_fixture.c",
        "unity/unity_memory.c",
    ]

    unity_config = ["UNITY_INCLUDE_DOUBLE", "UNITY_SUPPORT_64"]

    ctx(
        defines=unity_config,
        features="c",
        target="unity",
        source=unity_source
    )

    # Test main.
    common_source = [
        "common/tests_main.c",
        "common/caltime.c",
        "common/sockaddrtest.c",
    ]

    # libntp/
    libntp_source = [
        "libntp/authkeys.c",
        "libntp/ntp_calendar.c",
        "libntp/ntp_endian.c",
        "libntp/ntp_random.c",
        "libntp/clocktime.c",
        "libntp/decodenetnum.c",
        "libntp/dolfptoa.c",
        "libntp/hextolfp.c",
        "libntp/lfpfunc.c",
        "libntp/lfptostr.c",
        "libntp/macencrypt.c",
        "libntp/numtoa.c",
        "libntp/prettydate.c",
        "libntp/refidsmear.c",
        "libntp/socktoa.c",
        "libntp/statestr.c",
        "libntp/timespecops.c",
        "libntp/vi64ops.c",
        "libntp/ymd2yd.c"
    ] + common_source

    ctx.ntp_test(
        features="c cprogram test",
        target="test_libntp",
        install_path=None,
        defines=unity_config + ["TEST_LIBNTP=1"],
        includes=[ctx.bldnode.parent.abspath(), "../include", "unity", "common"],
        use="unity ntp parse M PTHREAD CRYPTO RT SOCKET NSL",
        source=libntp_source,
    )

    if ctx.env.REFCLOCK_GENERIC or ctx.env.REFCLOCK_TRIMBLE:
        # libparse available/required with generic and Trimble refclocks

        # libparse/
        libparse_source = [
            "libparse/binio.c",
            "libparse/gpstolfp.c",
            "libparse/ieee754io.c",
        ] + common_source

        ctx.ntp_test(
            defines=unity_config + ["TEST_LIBPARSE=1"],
            features="c cprogram test",
            includes=[ctx.bldnode.parent.abspath(), "../include", "unity"],
            install_path=None,
            lib=["parse"],
            libpath=["libparse"],
            source=libparse_source,
            target="test_libparse",
            use="unity ntp parse M PTHREAD RT SOCKET NSL",
        )

    ntpd_source = [
        # "ntpd/filegen.c",
        "ntpd/leapsec.c",
        "ntpd/restrict.c",
        "ntpd/recvbuff.c",
    ] + common_source

    if not ctx.env.DISABLE_NTS:
      ntpd_source += [
        "ntpd/nts.c",
        "ntpd/nts_client.c",
        "ntpd/nts_server.c",
        "ntpd/nts_cookie.c",
        "ntpd/nts_extens.c",
    ]

    ctx.ntp_test(
        defines=unity_config + ["TEST_NTPD=1"],
        features="c cprogram test",
        includes=[ctx.bldnode.parent.abspath(), "../include", "unity", "../ntpd", "common", "../libaes_siv"],
        install_path=None,
        source=ntpd_source,
        target="test_ntpd",
        use="ntpd_lib libntpd_obj unity ntp aes_siv "
            "M PTHREAD CRYPTO RT SOCKET NSL",
    )

    testpylib.get_bld().mkdir()

    pypath = pylib.get_bld()
    targdir = "tests/pylib"
    linkpath = ctx.bldnode.make_node(targdir + "/ntp").abspath()
    relpath = ("../" * (targdir.count("/")+1)) + pypath.path_from(ctx.bldnode)
    if (not os.path.exists(linkpath)) or os.readlink(linkpath) != relpath:
        try:
            os.remove(linkpath)
        except OSError:
            pass
        os.symlink(relpath, linkpath)

    pytests = ["pylib/test_util.py",
               "pylib/test_agentx.py",
               "pylib/test_agentx_packet.py",
               "pylib/test_ntpc.py",
               "pylib/test_packet.py",
               "pylib/test_statfiles.py"]

    ctx(
        features="subst",
        source=testpysrc,
        target=[x.get_bld() for x in testpysrc],
        chmod=Utils.O755,
    )

    for path in pytests:
        ctx(
            features="py test_scripts",
            test_scripts_source=path,
            test_scripts_template="${PYTHON} ${SRC}",
        )

=== attic/samba/Makefile ===
# Hi


PROGS = fake-samba fake-ntp-server fake-ntp-client

# Compiler flags
CFLAGS = -O1 -Wall -Wstrict-prototypes -Wmissing-prototypes

all: \
	$(PROGS)

clean:
	rm $(PROGS)

fake-samba: fake.h fake-samba.c
	cc $(CFLAGS) -g -o fake-samba fake-samba.c

fake-ntp-server: fake.h fake-ntp-server.c
	cc $(CFLAGS) -g -o fake-ntp-server fake-ntp-server.c

fake-ntp-client: fake.h fake-ntp-client.c
	cc $(CFLAGS) -g -o fake-ntp-client fake-ntp-client.c

=== debian/changelog ===
ntpsec (1.2.3+dfsg1-8) unstable; urgency=medium

  * Set STA_UNSYNC on start (Closes: 1103964)

 -- Richard Laager <rlaager@debian.org>  Fri, 02 May 2025 16:17:48 -0500

ntpsec (1.2.3+dfsg1-7) unstable; urgency=medium

  * Disable libaes-siv test_malloc_failure (Closes: 1102745)

 -- Richard Laager <rlaager@debian.org>  Mon, 14 Apr 2025 23:52:49 -0500

ntpsec (1.2.3+dfsg1-6) unstable; urgency=medium

  * Specify PYTHONDIR/PYTHONARCHDIR at waf configure (Closes: 1102962)

 -- Richard Laager <rlaager@debian.org>  Mon, 14 Apr 2025 03:26:53 -0500

ntpsec (1.2.3+dfsg1-5) unstable; urgency=medium

  * Backport more armhf fixes (Closes: 1091303)
  * Stop running with real-time priority (Closes: 1086000)

 -- Richard Laager <rlaager@debian.org>  Tue, 08 Apr 2025 00:54:46 +0000

ntpsec (1.2.3+dfsg1-4) unstable; urgency=low

  [ Richard Laager ]
  * ntplogtemp: Handle OSError.
    Thanks to Daniel <daniel@developerdan.com> (Closes: 1098368)
  * Fix ntpviz cron errors (when uninstalled) (Closes: 1098796)
  * Add more checks to ntpviz cron
  * Remove ntpsec.timer systemd-cron workaround (Closes: 1098745)
  * Add patch to fix out of bounds read.
    Thanks to Artem Nasonov
  * Handle BrokenPipeError in ntpq (Closes: 1092198)
  * Depend on python3-setuptools (Closes: 1080689)

  [ Joachim Kross ]
  * Docs: ntpdate no longer supports "-o"
  * ntp.conf: Specific paths for NTS certificate/key
  * Leverage ntpd's hourly leap-seconds.list file check & auto reload

  [ Richard Laager ]
  * Update leap-seconds.list URL (Closes: 1089713)
  * Backport armhf fixes (Closes: 1091303)
  * Drop transitional packages (Closes: 1072973)

 -- Richard Laager <rlaager@debian.org>  Sat, 01 Mar 2025 00:39:28 -0600

ntpsec (1.2.3+dfsg1-3) unstable; urgency=low

  [ Joachim Kross ]
  * Drop "nopeer" option of restrict command from configuration

 -- Richard Laager <rlaager@debian.org>  Mon, 06 May 2024 22:11:50 -0500

ntpsec (1.2.3+dfsg1-2) unstable; urgency=medium

  [ Joachim Kross ]
  * Add usestats log file to NTPsec apparmor profile
  * Add nts-keys-tmp to NTPsec apparmor profile

  [ Richard Laager ]
  * Update Standards-Version (no changes)

 -- Richard Laager <rlaager@debian.org>  Tue, 30 Apr 2024 00:21:46 -0500

ntpsec (1.2.3+dfsg1-1) unstable; urgency=low

  [ Richard Laager ]
  * New upstream version
    - Change mode6 alignment to four, which may break some compatibility with
      classic NTP.
    - Make ntpq stop dropping output timestamp leading zeroes.
    - Reset some stats hourly, even when not logged into files.
    - Add error logging, and stats for ms-sntp.
    - We think we have fixed ms-sntp
      Thanks to Jakob Haufe for testing. (Closes: 1033088)
    - ntpd and ntpq both treat SHA-1 as an alias for SHA1.  NIST uses SHA-1.
      The crypto package from OpenSSL uses SHA1.
    - The default crypto type for ntpq is now AES.  RFC 8573 deprecated MD5.
    - There are now log files with hourly statistics for NTS and NTS-KE
      traffic: filegen ntsstats and filegen ntskestats,
    - Fix ntploggps issue where count_used_satellites checked before it is
      initialized.
    - Add support for ecdhcurves list.
    - Fix ntpdig crash when using 2.ntp.pool.org with a host without IPv6
      support.
    - ntpdig shows packet delay in JSON output.
  * Install systemd ntp-units.d file (Closes: 1065567)
  * Switch pkg-config for pkgconf
  * Change systemd build-dep to systemd-dev (Closes: 1058451, 1060506)

  [ Simon Hyde ]
  * Fixup if-up scripts, fixes #1059931/#931414 (Closes: 1059931, 931414)

 -- Richard Laager <rlaager@debian.org>  Sun, 10 Mar 2024 22:01:29 -0500

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: ntpsec
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Richard Laager <rlaager@debian.org>
+Maintainer: Richard Laager <rlaager@debian.org>
 Build-Depends: debhelper-compat (= 13),
                dh-apache2,
                dh-apparmor,

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/default.mk
include /usr/share/dpkg/pkg-info.mk

export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow,+pie
export DEB_CFLAGS_MAINT_APPEND = -fno-strict-aliasing
export systemdsystemunitdir = $(shell pkg-config --variable=systemdsystemunitdir systemd)

%:
	dh $@ --with apache2,python3

override_dh_auto_configure:
ifeq (hurd, $(DEB_HOST_ARCH_OS))
	# hurd does not provided the system calls needed for ntpd to work.
	exit 1
endif
	# Only build with refclocks NOT slated for removal.  See also
	# debian/patches/update-refclock-docs.patch.  However, if the reason
	# for deprecation is only "two digit years", I *am* keeping it.
	#
	# Upstream references:
	# https://www.ntpsec.org/removal-plan.html
	# https://www.ntpsec.org/drivers.html
	#
	# Also drop modem.  It "requires a Hayes-compatible 1200bps modem,
	# hardware now 20 years obsolete".
	#
	# gpsd is a tough call.  It's not deprecated upstream, and it still can
	# work.  However, upstream recommends the use of SHM, as does every
	# example HOWTO I found with a quick search.  Furthermore, it is buggy:
	#   https://lists.ntpsec.org/pipermail/devel/2016-October/002392.html
	# Also, it "makes all sorts of non-standard assumptions about how gpsd
	# is configured.  A configuration that is contorted and non-obvious":
	#   https://lists.ntpsec.org/pipermail/devel/2016-October/002422.html
	# Most importantly, it is an attractive nuisance.  If someone is told
	# that the best practice is to use "gpsd", they might logically think
	# they should use the gpsd driver.  Skipping the gpsd driver also avoids
	# using the embedded copy of libjsmn.
	#
	# We pass LDFLAGS as LINKFLAGS because LINKFLAGS appears first in the
	# command line.  Debian wants to build with -fPIE for security reasons.
	# This is not compatible with building shared libraries like the ntpc
	# python extension.  If the -fPIE flag comes before -shared (or -fPIC),
	# the latter will override, and the build succeeds.
	CFLAGS='$(CFLAGS) $(CPPFLAGS)' \
	LDFLAGS='' \
	LINKFLAGS='$(LDFLAGS)' \
		python3 waf configure \
		--pythonarchdir=/usr/lib/python3/dist-packages \
		--pythondir=/usr/lib/python3/dist-packages \
		--pyshebang=/usr/bin/python3 \
		--prefix=/usr --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--enable-debug \
		--enable-mssntp --enable-warnings \
		--refclock=local,spectracom,generic,arbiter,nmea,pps,hpgps,shm,trimble,jjy,zyfer \
		--enable-doc --htmldir=/usr/share/doc/ntpsec/html

override_dh_auto_build:
	python3 waf build -v

override_dh_auto_clean:
	python3 waf clean || true
	rm -rf \
		build \
		.lock-waf_*_build \
		ntpclients/ntp \
		ntpd/version.h \
		.waf* \
		wafhelpers/autorevision.sh
	find -name "*.pyc" -delete

override_dh_install:
	python3 waf install --destdir=$(CURDIR)/debian/tmp
	mv \
		debian/tmp/$(systemdsystemunitdir)/ntpd.service \
		debian/tmp/$(systemdsystemunitdir)/ntpsec.service
	mv \
		debian/tmp/$(systemdsystemunitdir)/ntp-wait.service \
		debian/tmp/$(systemdsystemunitdir)/ntpsec-wait.service
	rm -rf debian/tmp/usr/lib/python3/dist-packages/ntp/__pycache__
	# ntpfrob probes internal, mostly undocumented settings.  It is
	# extremely unlikely that anyone needs this.
	#
	# ntpsnmpd is experimental.  If support for it is desired, then
	# it can be installed, but it will require some patching of file
	# paths to be compliant with Debian best practices.  It also needs
	# more documentation on how to integrate with snmpd.
	#
	# From ntpsweep.1, "ntpsweep relies on ntpq and Mode 6 queries to
	# probe servers. This depends on the remote host's restrict
	# configuration allowing queries. Nowadays effectively all public
	# hosts set noquery, so this script is unlikely to be useful unless
	# you have multiple specially-configured timeservers on a LAN."  The
	# default ntp.conf from this package also sets "noquery" (with an
	# exception for localhost).
	rm \
		debian/tmp/usr/bin/ntpfrob \
		debian/tmp/usr/bin/ntpsnmpd \
		debian/tmp/usr/bin/ntpsweep \
		debian/tmp/usr/share/man/man1/ntpsweep.1 \
		debian/tmp/usr/share/man/man8/ntpfrob.8 \
	        debian/tmp/usr/share/man/man8/ntpsnmpd.8
	mv \
		debian/tmp/usr/bin/ntptime \
		debian/tmp/usr/bin/ntpkeygen \
		debian/tmp/usr/bin/ntploggps \
		debian/tmp/usr/bin/ntplogtemp \
		debian/tmp/usr/bin/ntpwait \
		debian/tmp/usr/sbin/
	install -m 755 \
		attic/ntpdate \
		debian/tmp/usr/sbin
	# Sometimes we get the timestamp from the tarball and sometimes we get
	# a more recent timestamp (probably build time?).  The latter gets
	# clamped to the debian/changelog timestamp when the .deb is built,
	# but the tarball timestamp does not (as it is older).  This forces
	# all the timestamps to be newer so they all get clamped.
	find $(CURDIR)/debian/tmp/usr/share/doc/ntpsec/html -type f \
		-exec touch {} \+

	install -d debian/ntpsec/etc/letsencrypt/renewal-hooks/deploy
	install -m 755 \
		debian/ntpsec.certbot \
		debian/ntpsec/etc/letsencrypt/renewal-hooks/deploy/ntpsec

	install -d debian/ntpsec/$(systemdsystemunitdir)
	install -m 644 \
		debian/ntpsec.ntpsec-rotate-stats.service \
		debian/ntpsec/$(systemdsystemunitdir)/ntpsec-rotate-stats.service
	install -m 644 \
		debian/ntpsec.ntpsec-rotate-stats.timer \
		debian/ntpsec/$(systemdsystemunitdir)/ntpsec-rotate-stats.timer

	install -d debian/ntpsec-ntpviz/$(systemdsystemunitdir)
	install -m 644 \
		etc/ntploggps.service \
		etc/ntploggps.timer \
		debian/ntpsec-ntpviz/$(systemdsystemunitdir)

	install -d debian/ntpsec-ntpviz/etc/ntpviz/day
	install -m 644 www/day/footer \
		debian/ntpsec-ntpviz/etc/ntpviz/day/footer.html
	install -m 644 www/day/header \
		debian/ntpsec-ntpviz/etc/ntpviz/day/header.html
	install -m 644 www/index.html \
		debian/ntpsec-ntpviz/etc/ntpviz/index.html
	install -m 644 debian/ntpviz.options \
		debian/ntpsec-ntpviz/etc/ntpviz/options
	install -d debian/ntpsec-ntpviz/etc/ntpviz/week
	install -m 644 www/week/footer \
		debian/ntpsec-ntpviz/etc/ntpviz/week/footer.html
	install -m 644 www/week/header \
		debian/ntpsec-ntpviz/etc/ntpviz/week/header.html

	install -d debian/ntpsec-ntpviz/usr/share/ntpsec-ntpviz/ntpviz
	install -m 644 \
		www/favicon.ico \
		www/ntpsec-logo.png \
		debian/ntpsec-ntpviz/usr/share/ntpsec-ntpviz/ntpviz

	install -D -m 0755 debian/ntpdate-debian \
		debian/ntpsec-ntpdate/usr/sbin/ntpdate-debian
	install -D -m 0644 debian/ntpsec.dhcp \
		debian/ntpsec/etc/dhcp/dhclient-exit-hooks.d/ntpsec
	install -D -m 0755 debian/ntpsec.networkmanager \
		debian/ntpsec/usr/lib/NetworkManager/dispatcher.d/ntpsec
	install -D -m 0644 debian/ntpsec-ntpdate.dhcp \
		debian/ntpsec-ntpdate/etc/dhcp/dhclient-exit-hooks.d/ntpsec-ntpdate
	install -D -m 0755 debian/ntpsec-ntpdate.networkmanager \
		debian/ntpsec-ntpdate/usr/lib/NetworkManager/dispatcher.d/ntpsec-ntpdate
	install -D -m 0644 debian/ntpsec-systemd-netif.path \
		debian/ntpsec/$(systemdsystemunitdir)/ntpsec-systemd-netif.path
	install -D -m 0644 debian/ntpsec-systemd-netif.service \
		debian/ntpsec/$(systemdsystemunitdir)/ntpsec-systemd-netif.service

ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
	install -D -m 0644 debian/ntp.conf.ubuntu debian/ntpsec/etc/ntpsec/ntp.conf
else
	install -D -m 0644 debian/ntp.conf debian/ntpsec/etc/ntpsec/ntp.conf
endif
	install -D -m 0644 debian/ntpviz.conf \
		debian/ntpsec-ntpviz/etc/ntpsec/ntp.d/ntpviz.conf

	# install apparmor profile
	install -D -m 0644 debian/apparmor-profile \
		debian/ntpsec/etc/apparmor.d/usr.sbin.ntpd
	install -D -m 0644 debian/apparmor-profile.tunable \
		debian/ntpsec/etc/apparmor.d/tunables/ntpd
	dh_link -pntpsec etc/apparmor.d/usr.sbin.ntpd \
		etc/apparmor/init/network-interface-security/usr.sbin.ntpd

	# install apport hook
	install -D -m 644 debian/source_ntpsec.py \
		debian/ntpsec/usr/share/apport/package-hooks/source_ntpsec.py

	dh_link
	dh_install

override_dh_installinit-arch:
	dh_installinit -pntpsec --error-handler=installinit_error
	dh_installinit -pntpsec-ntpviz --name=ntpviz

## ntpsec 1.2.4%2Bdfsg

=== debian/changelog ===
ntpsec (1.2.4+dfsg-1) unstable; urgency=low

  * New upstream version (Closes: 1127000)
    - Fix ntpviz's skewness and kurtosis formulas. Fix suggested by
      Frank Davis.
    - ntpd now runs on FIPS mode systems.
    - Clock fuzzing is gone.
    - Fix distinct rpeers mode in PeerSummary.summary.
    - ntpd can now listen on a second port.  Add either "nts port xxxx"
      or "extra port xxxx" in your config file.  If either is specified,
      the NTS-KE server will tell the client to use that port.  Client
      requests will also be sent from that port.
    - NTPsec now builds on Linux armhf.
    - Remove some remnant broadcast/multicast cruft.
    - Add a ntpdig option to bind to a specific address.
    - Add an ntpd config file option for the NTS-KE server's preferred TLS
      ciphers.
    - Remove unused holdover, LOOP_KERN_CLEAR and timetoa from ntpd.
    - Add and revise exponential timing decay and MS-SNTP testing tools.
  * ntpsec-systemd-netif.service: Simplify /bin/sh
    Thanks to Christoph Anton Mitterer <calestyo@scientia.org>
    (Closes: 1121536)
  * ntpsec-systemd-netif.service: Conditionalize on the existence of the hook
    (Closes: 1121536)
  * ntp.conf: Add nomrulist to "restrict default"
    Thanks to Dave Hart <davehart@gmail.com> (Closes: 1108327)
  * Build the gpsd JSON driver (Closes: 1108417)
  * Update to Standards-Version 4.7.3

 -- Richard Laager <rlaager@debian.org>  Sat, 07 Feb 2026 23:22:59 -0600

## ntpsec 1.2.4+dfsg

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,5 @@
 Source: ntpsec
 Section: net
-Priority: optional
 Maintainer: Richard Laager <rlaager@debian.org>
 Build-Depends: debhelper-compat (= 13),
                dh-apache2,
@@ -11,6 +10,7 @@
                docbook-xsl,
                libbsd-dev,
                libcap2-dev [linux-any],
+               libjsmn-dev,
                libssl-dev,
                netbase,
                pkgconf,
@@ -25,8 +25,7 @@
 Build-Conflicts: libavahi-compat-libdnssd-dev,
                  libwww-dev,
                  libwww-ssl-dev,
-Standards-Version: 4.7.0
-Rules-Requires-Root: no
+Standards-Version: 4.7.3
 Vcs-Browser: https://salsa.debian.org/debian/ntpsec
 Vcs-Git: https://salsa.debian.org/debian/ntpsec.git
 Homepage: https://www.ntpsec.org

=== debian/rules ===
--- 
+++ 
@@ -26,18 +26,6 @@
 	#
 	# Also drop modem.  It "requires a Hayes-compatible 1200bps modem,
 	# hardware now 20 years obsolete".
-	#
-	# gpsd is a tough call.  It's not deprecated upstream, and it still can
-	# work.  However, upstream recommends the use of SHM, as does every
-	# example HOWTO I found with a quick search.  Furthermore, it is buggy:
-	#   https://lists.ntpsec.org/pipermail/devel/2016-October/002392.html
-	# Also, it "makes all sorts of non-standard assumptions about how gpsd
-	# is configured.  A configuration that is contorted and non-obvious":
-	#   https://lists.ntpsec.org/pipermail/devel/2016-October/002422.html
-	# Most importantly, it is an attractive nuisance.  If someone is told
-	# that the best practice is to use "gpsd", they might logically think
-	# they should use the gpsd driver.  Skipping the gpsd driver also avoids
-	# using the embedded copy of libjsmn.
 	#
 	# We pass LDFLAGS as LINKFLAGS because LINKFLAGS appears first in the
 	# command line.  Debian wants to build with -fPIE for security reasons.
@@ -54,8 +42,8 @@
 		--prefix=/usr --libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
 		--enable-debug \
 		--enable-mssntp --enable-warnings \
-		--refclock=local,spectracom,generic,arbiter,nmea,pps,hpgps,shm,trimble,jjy,zyfer \
-		--enable-doc --htmldir=/usr/share/doc/ntpsec/html
+		--refclock=arbiter,generic,gpsd,hpgps,jjy,local,nmea,pps,shm,spectracom,trimble,zyfer \
+		--enable-doc --htmldir=/usr/share/doc/ntpsec-doc/html
 
 override_dh_auto_build:
 	python3 waf build -v
@@ -64,6 +52,7 @@
 	python3 waf clean || true
 	rm -rf \
 		build \
+		libjsmn \
 		.lock-waf_*_build \
 		ntpclients/ntp \
 		ntpd/version.h \
@@ -101,7 +90,7 @@
 		debian/tmp/usr/bin/ntpsweep \
 		debian/tmp/usr/share/man/man1/ntpsweep.1 \
 		debian/tmp/usr/share/man/man8/ntpfrob.8 \
-	        debian/tmp/usr/share/man/man8/ntpsnmpd.8
+		debian/tmp/usr/share/man/man8/ntpsnmpd.8
 	mv \
 		debian/tmp/usr/bin/ntptime \
 		debian/tmp/usr/bin/ntpkeygen \
@@ -117,7 +106,7 @@
 	# clamped to the debian/changelog timestamp when the .deb is built,
 	# but the tarball timestamp does not (as it is older).  This forces
 	# all the timestamps to be newer so they all get clamped.
-	find $(CURDIR)/debian/tmp/usr/share/doc/ntpsec/html -type f \
+	find $(CURDIR)/debian/tmp/usr/share/doc/ntpsec-doc/html -type f \
 		-exec touch {} \+
 
 	install -d debian/ntpsec/etc/letsencrypt/renewal-hooks/deploy
@@ -201,3 +190,25 @@
 override_dh_installinit-arch:
 	dh_installinit -pntpsec --error-handler=installinit_error
 	dh_installinit -pntpsec-ntpviz --name=ntpviz
+	dh_installinit -pntpsec-ntpdate
+ifeq (yes,$(shell dpkg-vendor --derives-from Ubuntu && echo yes))
+	install -m 644 debian/ntpsec-ntpdate.default.ubuntu \
+		debian/ntpsec-ntpdate/etc/default/ntpsec-ntpdate
+endif
+	dh_apparmor --profile-name=usr.sbin.ntpd -pntpsec
+
+override_dh_installsystemd:
+	dh_installsystemd -pntpsec \
+		ntpsec.service \
+		ntpsec-systemd-netif.path \
+		ntpsec-rotate-stats.timer
+	dh_installsystemd -pntpsec-ntpviz \
+		ntploggps.timer \
+		ntplogtemp.timer \
+		ntpviz-daily.timer \
+		ntpviz-weekly.timer
+
+override_dh_makeshlibs:
+	# This avoids an unnecessary trigger of ldconfig.  libntpc.so is not
+	# installed in a system library path.
+	dh_makeshlibs -n

=== debian/watch ===
version=4
opts="\
    pasv,\
    compression=xz,repack,\
    dversionmangle=s/\+dfsg\d*$//,\
    oversionmangle=s/$/+dfsg/,\
    pgpsigurlmangle=s/$/.asc/" \
  https://ftp.ntpsec.org/pub/releases/@PACKAGE@@ANY_VERSION@@ARCHIVE_EXT@ \
  debian debian/repack-waf
